'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var isObject = function isObject(value) {
  return (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object' && value !== null && !Array.isArray(value);
};

/**
 * Extracts static and dynamic styles objects separately
 */
var getSeparatedStyles = function getSeparatedStyles(styles) {
  var result = {};

  for (var key in styles) {
    var value = styles[key];
    var itemStyles = {};

    if (typeof value === 'function') itemStyles.dynamicStyle = value;else if (isObject(value)) Object.assign(itemStyles, getSeparatedStyles(value));else itemStyles.staticStyle = value;

    for (var styleType in itemStyles) {
      result[styleType] = result[styleType] || {};
      result[styleType][key] = itemStyles[styleType];
    }
  }

  return result;
};

exports.default = getSeparatedStyles;